{% if form.form_errors %}
    {% for error in form.form_errors %}
        <div class="alert alert-danger" role="alert">{{error}}</div>
    {% endfor %}
{% endif %}

{% for field in form %}
    {% if field.widget.input_type != 'hidden' %}
    <div class="form-group">
        {{field.label}}:
        {% if field.data or field.errors %}
            {% if field.errors %}
            {{field(class="form-control is-invalid")}}
                {% for error in field.errors %}
                <div class="invalid-feedback">{{error}}</div>
                {% endfor %}
            {% else %}
            {{field(class="form-control is-valid")}}
            {% endif %}
        {% else %}
        {{field(class="form-control")}}
        {% endif %}
    </div>
    {% else %}
        {{field}}
    {% endif %}
{% endfor %}